<!DOCTYPE html>
<html lang="en">

  <head>
    <meta charset="UTF-8">
    <title>Shopping List App</title>
    <link rel="stylesheet" href="main.css">
  </head>
  
  <body>
  
    <div id="shopping-list">
      <div class="header">
        <h1>{{ header.toLocaleUpperCase() }}</h1> 
        <button v-if="state === 'default'" class="btn btn-primary" @click="changeState('edit')">Add Item</button>
        <button v-else class="btn btn-cancel" @click="changeState('default')">Cancel</button>
      </div>
      
      <div v-if="state === 'edit'" class="add-item-form">
          <input type="text" 
                 v-model="newItem" 
                 placeholder="Add an item" 
                 @keyup.enter="newItemEnterPressed">
                 
          <p>{{ characterCount }}/200</p>
                 
          <button class="btn btn-primary" 
                  :disabled="newItem.length === 0"
                  @click="saveItemButtonClicked">
                  Save item
          </button>
      </div>      
      
      <ul>
        <li v-for="item in reversedItems" :class="{strikeout: item.purchased, priority: item.highPriority}" @click="togglePurchased(item)">{{ item.label }}</li>
      </ul>
      
      <p v-if="items.length === 0 || allItemsPurchased()">Nice job! You've bought all your items.</p>
    </div> 
    
    <script src="https://unpkg.com/vue"></script>
    <script>
      var shoppingList = new Vue({
        el: '#shopping-list',
        data: {
          state: 'default',
          header: 'shopping list app',
          newItem: '',
          items: [
            {
              label: '10 party hats',
              purchased: false,
              highPriority: false,
            },
            {
              label: '2 board games',
              purchased: true,
              highPriority: false,
            },
            {            
              label: '20 cups',
              purchased: false,
              highPriority: true,
            }
          ],
        },
        methods: {
            newItemEnterPressed: function (event) {
                console.log("Enter pressed");
                this.addNewItem();
            },
            newItemChanged: function (event) {
                console.log("newItemChanged", this.newItem);
                if (this.newItem.length >= 3) {
                  console.log("Doing HTTP request");
                }
            },
            saveItemButtonClicked: function (event) {
                console.log("saveItemButtonClicked");
                this.addNewItem();
            },
            addNewItem: function() {
              this.items.push({label: this.newItem, purchased: false});
              this.newItem = '';
            },
            changeState: function(newState) {
              this.state = newState;
              this.newItem = '';
            },
            togglePurchased: function (item) {
              item.purchased = !item.purchased;
            },
            allItemsPurchased: function() {
              for (var i in this.items) {
                if (this.items[i].purchased === false) {
                  return false;
                }
              }
              return true;
            },
        },
        computed: {
          characterCount() {
            return this.newItem.length;
          },
          reversedItems() {
            return this.items.slice(0).reverse();
          },
        },
        watch: {
          newItem: function(val, oldVal) {
            console.log("newItemChanged", oldVal, val);
            if (val.length >= 3) {
              console.log("[OK] Doing HTTP request");
            } else {
              console.log('newItem value too low!', val);
            }
          },
        },
      });
    </script>
  </body>
</html>
